// vim: set tw=80 ts=2 sw=2 sts=2 :

import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { ReactiveFormsModule } from '@angular/forms';
import { HttpClientModule } from '@angular/common/http';
import { RouterModule } from '@angular/router';

import { NgLoggerModule, Level } from '@nsalaun/ng-logger';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { NgxChartsModule } from '@swimlane/ngx-charts';
import { ToastrModule } from 'ngx-toastr';
import { TextMaskModule } from 'angular2-text-mask';
import { jqxChartComponent } from 'jqwidgets-scripts/jqwidgets-ts/angular_jqxchart';

import { BalanceChartComponent } from './balanceChart.component';
import { CategoryChartComponent } from './categoryChart.component';
import { OperationRowComponent } from './operationRow.component';
import { CategoryService } from './category.service';
import { OperationService } from './operation.service';
import { OperationListComponent } from './operationList.component';
import { OperationDeleteModalComponent } from './operationDeleteModal.component';
import { OperationFormComponent } from './operationForm.component';
import { OperationEditModalComponent } from './operationEditModal.component';
import { OperationListState } from './operation.states';

@NgModule({
  imports: [
    HttpClientModule,
    CommonModule,
    ReactiveFormsModule,
    RouterModule.forChild([
      OperationListState
    ]),
    NgLoggerModule,
    ToastrModule,
    NgbModule,
    NgxChartsModule,
    TextMaskModule
  ],
  providers: [
    CategoryService,
    OperationService,
  ],
  declarations: [
    jqxChartComponent,
    BalanceChartComponent,
    CategoryChartComponent,
    OperationRowComponent,
    OperationListComponent,
    OperationDeleteModalComponent,
    OperationFormComponent,
    OperationEditModalComponent,
  ],
  entryComponents: [
    OperationDeleteModalComponent,
    OperationEditModalComponent,
    OperationListComponent,
  ]
})
export class OperationModule {}
